/****************************************************************************/
/**  Diverse Routinen fr alle (meist mit Pascal-Namen, hi)  dg6vj, jun 96 **/
/**                                                                        **/
/** Copyright 1996 Jochen Sarrazin, DG6VJ. All rights reserved.            **/
/****************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

char *random_state;


/* Kopiert 'count' Zeichen von 'src' nach 'dest' ab Position 'start'. 
   src und dest mssen 2 VERSCHIEDENE Strings sein! */
void COPY(char *dest, char *src, int start, int count)
{
  int from,to,i;

  i = 0;
  from = start;
  to = 0;
  while ((i<count) && (src[from]!='\0')) {
    dest[to] = src[from];
    i++;
    from++;
    to++;
  }
  dest[to] = '\0';
}


/* Wandelt alle Kleinbuchestaben in Grossbuchstaben um */
void Gross(char *str)
{
  int i;
  
  i=0;
  while (i<=strlen(str)) {
    if (((int)str[i]>=97) && ((int)str[i]<=122)) str[i] = str[i] - 32;
    i++;
  }
}


/* Wandelt alle Grossbuchestaben in Kleinbuchstaben um */
void Klein(char *str)
{
  int i;
  
  i=0;
  while (i<=strlen(str)) {
    if ((str[i]>='A') && (str[i]<='Z')) str[i] = str[i] + 32;
    i++;
  }
}



/* Wandelt einen Buchstaben in Grossbuchstaben um */
char upcase(char input)
{
  if ((input>=97) && (input<=122)) return(input-32);
  return(input);
}


/* Gibt die erste Position des Zeichens an, oder -1, wenn das Zeichen nicht in
   str ist */
int POS(char zeichen, char *str)
{
  int i,pos;
  
  i = 0;
  pos = -1;
  while ((str[i]!='\0') && (pos==-1)) {
    if (str[i]==zeichen) pos = i;
    i++;
  }
  
  return pos;
}



/* Schreibt das bergebene Zeichen anz mal in den dest-string */
void StringD(char *dest, int anz, char zeichen)
{
  int i=0;
  while (i<anz) {
    dest[i] = zeichen;
    i++;
  }
  dest[i] = '\0';
}



/* Alle Leerzeichen links vom String lschen */
void KillSpacesLeft(char *str)
{
  int anz=0,i=0,k=0;	/* anzahl leerzeichen */
  
  while ((str[i] != '\0') && (str[i] == ' ')) i++;
  if (str[i] == '\0') {
    str[0] = '\0';
    return;
  }
  
  /* Nur was machen, wenn sich auch was verndert hat */
  if (i>0) {
    while (str[i] != '\0') {
      str[k] = str[i];
      k++;
      i++;
    }
    str[k] = '\0';
  }
}



/* Alle Leerzeichen rechts lschen */
void KillSpacesRight(char *str)
{
  int i;
  
  i = strlen(str)-1;
  if (i < 0) return;
  
  while ((i>0) && (str[i] == ' ')) i--;
  str[i+1] = '\0';
}


/* Gre des bergebenen Files zurckgeben. Wenn nicht vorhanden wird -1 zurck gegeben. */
long filesize(char *filename)
{
  FILE *f;
  long i;
  
  f = fopen(filename,"r");
  
  if (f == NULL) return(-1);
  
  fseek(f,0,SEEK_END);
  i = ftell(f);
  fclose(f);
  
  return(i);
}


/* ALLE Leerzeichen in str lschen, und den sich dann ergebenen String nach tmp schreiben */
void KillAllSpaces(char *tmp, char *str)
{
  int i=0, k=0;
  
  while (str[i] != '\0') {
    if (str[i] != ' ') {
      tmp[k] = str[i];
      k++;
    }
    i++;
  }
  tmp[k] = '\0';
}


/* Wenn mehr als ein Leerzeichen nacheinander kommt, werden die brigen Leerzeichen
   gelscht. */
void OnlyOneSpace(char *tmp, char *str)
{
  int i=0, k=0, anz=0;
  
  while (str[i] != '\0') {
    if (str[i] != ' ') {
      tmp[k] = str[i];
      k++;
      anz = 0;
    }
    else {
      anz++;
      if (anz = 1) {
        tmp[k] = str[i];
        k++;
      }
    }
    
    i++;
  }
  tmp[k] = '\0';
}




/*
 * Lscht count Zeichen aus dem String str ab Position pos
 */
void delete(char *str, int pos, int count)
{
  int len;
  
  len = strlen(str);
  
  memmove(str+pos,str+pos+count,len-count);
  str[len-count] = '\0';
}


/*
 * Liest Zeichen bis zum nchsten vorkommen von sign aus dem File mit der bergebenen fd ein.
 *
 * Es findet KEINE berlaufprfung statt!
 */
int fdgets(int fd, char *str, char sign)
{
  char tmp[101];
  int count,count_wrote,ok,i,curpos;
  off_t startoffset;
  
  count_wrote = 0;
  
  str[0] = '\0';
  ok = 0;
  while (ok == 0) {
    /* Aktuellen Offset sichern */
    startoffset = lseek(fd,0,SEEK_CUR);
    count = read(fd,tmp,100);
    if (count != 100) ok = 1;
    /* An den Offset vor dem letzten Lesen springen */
    lseek(fd,startoffset,SEEK_SET);
    
    tmp[count] = '\0';
    if ((i = POS(sign,tmp)) == -1) {
      strcat(str,tmp);
    }
    else {
      tmp[i+1] = '\0';
      strcat(str,tmp);
      ok = 1;
    }
  }

  /* Den File-Zeiger neu positionieren */
  curpos = lseek(fd,strlen(str),SEEK_CUR);

  /* Gucken, ob wir am Ende des String sind */
  if (lseek(fd,0,SEEK_END) == curpos) return(-1);	/* Yo, am Ende */
  
  /* Nein, noch nicht am Ende */
  lseek(fd,curpos,SEEK_SET);
  return(0);
}



/* Guckt, ob str1 in str2 vorkommt, und gibt die Position davon zurck. -1, wenn nicht
 * vorhanden.
 */
int pos(char *str1, char *str2)
{
}



/* Wandelt den Integer-Wert in Hex-Zahlen um */
void int2hchar(int zahl, char *c1, char *c2)
{
  char hexzahl[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
  
  *c1 = hexzahl[zahl / 16];
  *c2 = hexzahl[zahl % 16];
}


/* Initialisierung der Random-Geschichte. */
void init_random()
{
  srand((int)time(NULL));
}



int file_exist(char *filename)
{
  int fd;
  
  if ((fd = open(filename,O_RDONLY)) == -1) {
    return(0);
  }
  else {
    close(fd);
    return(1);
  }
}




